package com.muyu.Hikari;

import com.muyu.domain.Source;
import com.zaxxer.hikari.HikariConfig;
import com.zaxxer.hikari.HikariDataSource;
import jakarta.validation.constraints.NotNull;

//连接池供所有连接是调用
public class HikariPool {
    public static HikariDataSource instance = null;
    @NotNull
    public static synchronized HikariDataSource getHikariDataSource(Source dataSources) {
        if(instance == null) {

            HikariConfig hikariConfig = new HikariConfig();
            hikariConfig.setPoolName("HikariCP 连接池");
            hikariConfig.setDriverClassName(dataSources.getDriverName());
            hikariConfig.setJdbcUrl(dataSources.getUrl());
            hikariConfig.setUsername(dataSources.getUsername());
            hikariConfig.setPassword(dataSources.getPassword());
            hikariConfig.setMinimumIdle(2);
            hikariConfig.setMaximumPoolSize(10);


//            com.mysql.cj.jdbc.Driver
//            hikariConfig.setJdbcUrl("jdbc:mysql://localhost:3306/yourDatabase");
//            hikariConfig.setDataSourceClassName(dataSources.getDriverName());
//            hikariConfig.addDataSourceProperty("user", dataSources.getUsername());
//            hikariConfig.addDataSourceProperty("password", dataSources.getPassword());
//            hikariConfig.addDataSourceProperty("url", dataSources.getUrl());
//
//            hikariConfig.setMaximumPoolSize(15);

            instance = new HikariDataSource(hikariConfig);
        }
        return instance;
    }
}
