package com.muyu.cloud.etl.controller;

import com.muyu.cloud.etl.service.AccreditService;
import com.muyu.cloud.etl.service.TableInfoService;
import com.muyu.common.core.domain.Result;
import com.muyu.domain.Accredit;
import com.muyu.domain.rep.AccreditDeptRep;
import com.muyu.domain.rep.AccreditUserRep;
import com.muyu.domain.req.AccreditReq;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/accredit")
public class AccreditController {
    @Autowired
    private AccreditService accreditService;
    @Autowired
    private TableInfoService tableInfoService;

    //根据表Id查询数据库名称接入名称和表名称
    @GetMapping("/findAccredit")
    public Accredit findAccredit(@RequestParam(value = "tableId") Long tableId) {
        return  accreditService.findAccredit(tableId);
    }

    //根据表Id和数据源Id查询
    @GetMapping("/findDeptListStatus")
    public Result findDeptListStatus(@RequestParam(value = "tableId") Long tableId,@RequestParam(value = "basicId") Long basicId) {
        List<AccreditDeptRep> repList=accreditService.findDeptListStatus(tableId,basicId);
        return  Result.success(repList);
    }

    //根据表Id和数据呀UN
    @GetMapping("/findUserListStatus")
    public Result findUserListStatus(@RequestParam(value = "tableId") Long tableId,@RequestParam(value = "basicId") Long basicId) {
        List<AccreditUserRep> repList=accreditService.findUserListStatus(tableId,basicId);
        return Result.success(repList);
    }

    //根据数据源ID,和表Id，部门Id和用户Id 进行添加中间表 添加权限
    @PostMapping("/addMiddle")
    public Result addMiddle(@RequestBody AccreditReq accreditReq) {

//        if(accreditReq.getTableId()==null&&accreditReq.getBasicId()!=null){
//
//        }
        Integer i=accreditService.addMiddle(accreditReq);
        return i>0?Result.success(i):Result.error();
    }


    //根据数据源Id,和表Id，部门Id和用户Id 删除中间表取消授权
    @PostMapping("/remove")
    public Result remove(@RequestBody AccreditReq accreditReq) {
        Integer i = accreditService.remove(accreditReq);
        return i>0?Result.success(i):Result.error();
    }



}
