package com.muyu.cloud.etl.controller;

import com.muyu.cloud.etl.service.DataValueService;
import com.muyu.common.core.domain.Result;
import com.muyu.domain.DataValue;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/DataValue")
public class DataValueController {
    @Autowired
    private DataValueService dataValueService;

    //获取字段值  供任务调用
    @PostMapping("/findTableValue")
    public Result<List<List<DataValue>>> findTableValue(@RequestParam("basicId") Long basicId,@RequestParam("sql") String sql) {
       List<List<DataValue>> list= dataValueService.findTableValue(basicId,sql);
       return Result.success(list);
    }


    //获取字段值
    @PostMapping("/findTableValueList")
    public Result findTableValueList(@RequestParam("basicId") Long basicId,@RequestParam("tableName") String tableName ) {
    List<DataValue> list= dataValueService.findTableValueList(basicId,tableName);
        return Result.success(list);
    }

    //添加数据库
    //根据值添加的表中
    @PostMapping("/addTable")
    public Result addTableDataValue(@RequestParam("basicId")  Long basicId,@RequestParam("tableId") Long tableId, @RequestBody List<List<DataValue>> dataValue) {
         Integer i = dataValueService.addTableDataValue(basicId,tableId,dataValue);
         return Result.success(i);
    }

    //根据任务提供的sql 查询数量
    @PostMapping("/findCount")
    public Integer findCount(@RequestParam("basicId") Long basicId,@RequestParam("sql") String sql) {
        return dataValueService.findCount(basicId,sql);
    }

    //获取字段值 供任务调用
    @PostMapping("/findTableValueToArray")
    public  DataValue[][] findTableValueToArray(@RequestParam("basicId") Long basicId, @RequestParam("sql") String sql,@RequestParam("one") Long one, @RequestParam("two") Integer two){
        return dataValueService.findTableValueArray(basicId,sql,one,two);
    }

















}
