package com.muyu.cloud.etl.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.cloud.etl.mapper.TableInfoMapper;
import com.muyu.cloud.etl.service.TableInfoService;
import com.muyu.domain.TableInfo;
import groovy.lang.Lazy;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Log4j2
public class TableServiceImpl extends ServiceImpl<TableInfoMapper, TableInfo> implements TableInfoService {
    @Autowired
    @Lazy
    private TableInfoMapper tableInfoMapper;
//    @Autowired
//    private SourceService sourceService;
    @Override
    public TableInfo selectTableInfoByName(TableInfo tableInfoInsert) {
        LambdaQueryWrapper<TableInfo> tableInfoLambdaQueryWrapper = new LambdaQueryWrapper<>();
//        tableInfoLambdaQueryWrapper.eq(TableInfo::getId, tableInfoInsert.getId());
        //

        tableInfoLambdaQueryWrapper.eq(TableInfo::getBasicId, tableInfoInsert.getBasicId());
        tableInfoLambdaQueryWrapper.eq(TableInfo::getTableName, tableInfoInsert.getTableName())
                .eq(TableInfo::getParentId, tableInfoInsert.getParentId());

        return  this.tableInfoMapper.selectOne(tableInfoLambdaQueryWrapper);
    }

    @Override
    public List<TableInfo> findSourceList() {
        List<TableInfo> tableInfoList = tableInfoMapper.selectList(new LambdaQueryWrapper<TableInfo>(TableInfo.class)
                .eq(TableInfo::getParentId, 0));

        return tableInfoList;
    }


//    @Override
//    public List<DataValue> findTableValue(Long basicId, String sql) {
//        Source source = sourceService.getInfo(basicId);
//        String host = source.getHost();
//        String port = source.getPort();
//        String databaseName = source.getDatabaseName();
//        String databaseType = source.getDatabaseType();
//        String url = "jdbc:" + databaseType + "://" + host + ":" + port + "/" + databaseName + "?" + source.getConnectionParams();
//        String user = source.getUsername();
//        String password = source.getPassword();
//
//        List<DataValue> list = new ArrayList<>();
//
//
//        Connection conn=null;
//        try {
//            conn = DriverManager.getConnection(url, user, password);
//            try {
//                PreparedStatement preparedStatement = conn.prepareStatement(sql);
//
//                ResultSet resultSet = preparedStatement.executeQuery();
//                ResultSetMetaData metaData = resultSet.getMetaData();
//                int columnCount = metaData.getColumnCount();
//
//
//                while (resultSet.next()){
//                    for (int i = 1; i <= columnCount; i++) {
//                        String columnTypeName = metaData.getColumnTypeName(i);
//
//                        DatabaseMetaData metaData1 = conn.getMetaData();
//                        ResultSet columns = metaData1.getColumns(null, null, metaData.getTableName(i), metaData.getColumnName(i));
//                        String remarks =null;
//                        while (columns.next()){
//                            remarks = columns.getString("REMARKS");
//
//                            log.info("字段备注:"+remarks);
//                        }
//                        DataValue build = DataValue.builder()
//                                .key(metaData.getColumnName(i))
//                                .label(remarks)
//                                .value(resultSet.getObject(i, DataType.convertType(columnTypeName)))
//                                .type(DataType.getJavaType(columnTypeName))
//                                .build();
//                        list.add(build);
//
//                    }
//                }
//            } catch (SQLException e) {
//                throw new RuntimeException(e);
//            }
//        } catch (SQLException e) {
//            throw new RuntimeException(e);
//        }
//
//        return list;
//    }
//
//    @Override
//    public List<DataValue> findTableValues(Long basicId, String tableName) {
//        Source source = sourceService.getInfo(basicId);
//        String host = source.getHost();
//        String port = source.getPort();
//        String databaseName = source.getDatabaseName();
//        String databaseType = source.getDatabaseType();
//        String url = "jdbc:" + databaseType + "://" + host + ":" + port + "/" + databaseName + "?" + source.getConnectionParams();
//        String user = source.getUsername();
//        String password = source.getPassword();
//        List<DataValue> list = new ArrayList<>();
//        Connection conn=null;
//
//        try {
//            conn = DriverManager.getConnection(url, user, password);
//            try {
//                PreparedStatement preparedStatement = conn.prepareStatement("select  *  from "+tableName);
//                ResultSet resultSet = preparedStatement.executeQuery();
//                ResultSetMetaData metaData = resultSet.getMetaData();
//                int columnCount = metaData.getColumnCount();
//                while (resultSet.next()){
//                    for (int i = 1; i <= columnCount; i++) {
//                        String columnTypeName = metaData.getColumnTypeName(i);
//
//                        DatabaseMetaData metaData1 = conn.getMetaData();
//
//                        ResultSet columns = metaData1.getColumns(null, null, metaData.getTableName(i), metaData.getColumnName(i));
//
//                        String remarks =null;
//
//                        while (columns.next()){
//                            remarks = columns.getString("REMARKS");
//                            log.info("字段备注:"+remarks);
//                        }
//                        DataValue build = DataValue.builder()
//                                .key(metaData.getColumnName(i))
//                                .label(remarks)
//                                .value(resultSet.getObject(i, DataType.convertType(columnTypeName)))
//                                .type(DataType.getJavaType(columnTypeName))
//                                .build();
//                        list.add(build);
//
//                    }
//                }
//            } catch (SQLException e) {
//                throw new RuntimeException(e);
//            }
//        } catch (SQLException e) {
//            throw new RuntimeException(e);
//        }
//
//
//        return list;
//    }


//    @Override
//    public List<TableInfoRep> findTablesList(Long id) {
//        List<TableInfo> tableInfoList = tableInfoMapper.selectList(new LambdaQueryWrapper<TableInfo>(TableInfo.class).eq(
//                TableInfo::getParentId, id
//        ));
//
//        List<TableInfoRep> tableInfoRepList = new ArrayList<>();
//        for (TableInfo tableInfo : tableInfoList) {
//            TableInfoRep tableInfoRep = TableInfo.tableInfoRep(tableInfo);
//            tableInfoRepList.add(tableInfoRep);
//        }
//
//        return tableInfoRepList;
//    }
}
